#ifndef GTTPDYNSET_H_
#define GTTPDYNSET_H_



#include <glib-object.h>

#include "gttp-fset.h"

/*
 *
 * Fundamental type, representing a set of objects.
 *
 * This will be registered with various fundamental and
 * type flags.
 *
 */
#define GTTP_TYPE_DYNSET           (gttp_type_dynset_t)
#define GTTP_DYNSET_CLASS(klass)   (G_TYPE_CHECK_CLASS_CAST ((klass), GTTP_TYPE_DYNSET, GTTPDynSetClass))
#define GTTP_IS_DYNSET_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), GTTP_TYPE_DYNSET))

#define GTTP_DYNSET(obj)  (G_TYPE_CHECK_INSTANCE_CAST ((obj), GTTP_TYPE_DYNSET,  GTTPDynSet))
#define GTTP_IS_DYNSET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj),  GTTP_TYPE_DYNSET))
#define GTTP_DYNSET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GTTP_TYPE_DYNSET, GTTPDynSetClass))



#define DYNSET_FIELD_PTR_INIT_VALUE 0x1EC3
#define DYNSET_FIELD_DBL_INIT_VALUE 1
#define DYNSET_FIELD_ICOUNT_INIT_VALUE 0

#define GTTP_TYPE_DYNSET_NAME          "GTTPDynSet"
#define GTTP_TYPE_DYNSET_CLASS_INFO    dynset_type_info


typedef struct _GTTPDynSet    GTTPDynSet;
typedef struct _GTTPDynSetClass GTTPDynSetClass;


struct _GTTPDynSet{
  GTTPFSet parent;

//Synthetic fields
  gint element_count;
  gpointer* elements;

// Diagnosing fields
  int instance_id;
};


struct _GTTPDynSetClass{
    GTTPFSetClass parent_class;


//--------------------------------------------------------
// Class static variables
    gdouble field_dbl;
    gpointer field_ptr;
};


//Very specific type registration function, to register this fundamental type
// with different combination of flags.
GType register_gttp_dynset_type();
GType test_register_gttp_dynset_type(GType parent_type,
                                     GTypePlugin* plugin,
                                     const gchar* type_name,
                                     GTypeFlags type_flags,
                                     const gpointer class_data);


extern GTypeInfo dynset_type_info;
extern GType gttp_type_dynset_t;

#endif /*GTTPDYNSET_H_*/
