#ifndef GTTPFSET_H_
#define GTTPFSET_H_

#include <stdio.h>
#include <glib-object.h>


/*
 *
 * Fundamental type, representing a set of objects.
 *
 * This will be registered with various fundamental and
 * type flags.
 *
 */
#define GTTP_TYPE_FSET           (register_gttp_fset_type(TRUE))
#define GTTP_TYPE_FSET_NO_INIT           (register_gttp_fset_type(FALSE))
#define GTTP_FSET_CLASS(klass)   (G_TYPE_CHECK_CLASS_CAST ((klass), GTTP_TYPE_FSET, GTTPFSetClass))
#define GTTP_IS_FSET_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), GTTP_TYPE_FSET))

#define GTTP_FSET(obj)  (G_TYPE_CHECK_INSTANCE_CAST ((obj), GTTP_TYPE_FSET,  GTTPFSet))
#define GTTP_IS_FSET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj),  GTTP_TYPE_FSET))
#define GTTP_FSET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GTTP_TYPE_FSET, GTTPFSetClass))





#define FSET_FIELD_PTR_INIT_VALUE 0x1EC3
#define FSET_FIELD_DBL_INIT_VALUE 1
#define FSET_FIELD_ICOUNT_INIT_VALUE 0

#define GTTP_TYPE_FSET_NAME          "GTTPFSet"


typedef struct _GTTPFSet    GTTPFSet;
typedef struct _GTTPFSetClass GTTPFSetClass;


struct _GTTPFSet{
  GTypeInstance parent;


};


struct _GTTPFSetClass{
    GTypeClass parent_class;


};


//Very specific type registration function, to register this fundamental type
// with different combination of flags.
GType register_gttp_fset_type(gboolean has_init);
GType test_register_gttp_fset_type( const gchar* type_name,
									GTypeFundamentalFlags fundamental_flags,
									GTypeFlags type_flags,
									const gpointer class_data,
									gboolean has_init);


#endif /*GTTPFSET_H_*/
