
#include "gttp-dynset.h"


static void gttp_dynset_base_init(gpointer g_class);
static void gttp_dynset_base_finalize(gpointer g_class);
static void gttp_dynset_class_init(gpointer g_class, gpointer class_data);
static void gttp_dynset_class_finalize(gpointer g_class, gpointer class_data);
static void gttp_dynset_instance_init(GTypeInstance *instance, gpointer g_class);



GType gttp_type_dynset_t = 0;



GTypeInfo dynset_type_info;

GType test_register_gttp_dynset_type(GType parent_type,
                                     GTypePlugin* plugin,
                                     const gchar* type_name,
                                     GTypeFlags type_flags,
                                     const gpointer class_data)
{

    gboolean is_classed = G_TYPE_IS_CLASSED(parent_type);
    gboolean is_instantiable = is_classed && G_TYPE_IS_INSTANTIATABLE(parent_type);


    guint16 class_size = is_classed ? sizeof(GTTPDynSetClass) : 0;

    GBaseInitFunc base_init_func = is_classed ? gttp_dynset_base_init : NULL;
    GBaseFinalizeFunc base_finalize_func = is_classed ? gttp_dynset_base_finalize : NULL;
    GClassInitFunc class_init_func = is_classed ? gttp_dynset_class_init : NULL;
    GClassFinalizeFunc class_finalize_func = is_classed? gttp_dynset_class_finalize: NULL;
    GInstanceInitFunc instance_init_func = (is_instantiable) ? gttp_dynset_instance_init : NULL;

    gconstpointer fclass_data = is_classed ? class_data : NULL;

    guint16 instance_size = is_instantiable ? sizeof(GTTPDynSet) : 0;

    dynset_type_info.class_size = class_size;
    dynset_type_info.base_init = base_init_func;
    dynset_type_info.base_finalize = base_finalize_func;
    dynset_type_info.class_init = class_init_func;
    dynset_type_info.class_finalize = class_finalize_func;
    dynset_type_info.class_data = fclass_data;
    dynset_type_info.instance_size = instance_size;
    dynset_type_info.n_preallocs = 0;
    dynset_type_info.instance_init = instance_init_func;
    dynset_type_info.value_table = NULL;


    const gchar* ctype_name = type_name == NULL ? "GTTPDynSet" : type_name;


    gttp_type_dynset_t = g_type_register_dynamic(parent_type,
                                                 ctype_name,
                                                 plugin,
                                                 type_flags);


    return gttp_type_dynset_t;
}


// Class initialization methods

static void gttp_dynset_base_init(gpointer g_class)
{
    printf("%s called.\n", __func__);
}

static void gttp_dynset_base_finalize(gpointer g_class)
{
    printf("%s called.\n", __func__);
}


static void gttp_dynset_class_init(gpointer g_class, gpointer class_data)
{
    printf("%s called.\n", __func__);
}


static void gttp_dynset_class_finalize(gpointer g_class, gpointer class_data)
{
    printf("%s called.\n", __func__);
}


//Instance initialization method

static void gttp_dynset_instance_init(GTypeInstance *instance, gpointer g_class)
{
    printf("%s called.\n", __func__);
}


//Public wrappers of the class methods





//Implementation of class methods


