
#include "gttp-fset.h"


static void gttp_fset_base_init(gpointer g_class);
static void gttp_fset_base_finalize(gpointer g_class);
static void gttp_fset_class_init(gpointer g_class, gpointer class_data);
static void gttp_fset_instance_init(GTypeInstance *instance, gpointer g_class);


GType gttp_type_fset_t = 0;

GType register_gttp_fset_type(gboolean has_init)
{
	static int gttp_type_fset = 0;
    if(gttp_type_fset == 0)
    {
        if(gttp_type_fset_t == 0){
            gttp_type_fset = test_register_gttp_fset_type(GTTP_TYPE_FSET_NAME,
        										 G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE |
        										 G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE,
        										 0, NULL, has_init);
        }else{
            gttp_type_fset = gttp_type_fset_t;
        }
    }
    return gttp_type_fset;
}



GTypeInfo fset_type_info;

GType test_register_gttp_fset_type( const gchar* type_name,
									GTypeFundamentalFlags fundamental_flags,
									GTypeFlags type_flags,
									const gpointer class_data, gboolean has_init)
{

    gboolean is_classed = (fundamental_flags & G_TYPE_FLAG_CLASSED) == G_TYPE_FLAG_CLASSED;
    gboolean is_instantiable = is_classed && (fundamental_flags & G_TYPE_FLAG_INSTANTIATABLE) == G_TYPE_FLAG_INSTANTIATABLE;

    GType next_ftypeid = g_type_fundamental_next();

    GTypeFundamentalInfo fndtype_info = {fundamental_flags};

    guint16 class_size = is_classed ? sizeof(GTTPFSetClass) : 0;

    GBaseInitFunc base_init_func = is_classed ? gttp_fset_base_init : NULL;
    GBaseFinalizeFunc base_finalize_func = is_classed ? gttp_fset_base_finalize : NULL;
    GClassInitFunc class_init_func = is_classed ? gttp_fset_class_init : NULL;
    GClassFinalizeFunc class_finalize_func = NULL;
    GInstanceInitFunc instance_init_func = (is_instantiable && has_init) ? gttp_fset_instance_init : NULL;

    gconstpointer fclass_data = is_classed ? class_data : NULL;

    guint16 instance_size = is_instantiable ? sizeof(GTTPFSet) : 0;

    fset_type_info.class_size = class_size;
    fset_type_info.base_init = base_init_func;
    fset_type_info.base_finalize = base_finalize_func;
    fset_type_info.class_init = class_init_func;
    fset_type_info.class_finalize = class_finalize_func;
    fset_type_info.class_data = fclass_data;
    fset_type_info.instance_size = instance_size;
    fset_type_info.n_preallocs = 0;
    fset_type_info.instance_init = instance_init_func;
    fset_type_info.value_table = NULL;


    const gchar* ctype_name = type_name == NULL ? GTTP_TYPE_FSET_NAME : type_name;


    gttp_type_fset_t = g_type_register_fundamental(
                                next_ftypeid,
                                ctype_name,
                                &fset_type_info,
                                &fndtype_info,
                                type_flags);

    return gttp_type_fset_t;
}


// Class initialization methods

static void gttp_fset_base_init(gpointer g_class)
{
    printf("%s called.\n", __func__);
}

static void gttp_fset_base_finalize(gpointer g_class)
{
    printf("%s called.\n", __func__);
}


static void gttp_fset_class_init(gpointer g_class, gpointer class_data)
{
    printf("%s called.\n", __func__);
}

static void gttp_fset_instance_init(GTypeInstance *instance, gpointer g_class)
{
    printf("%s called.\n", __func__);
}








